/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *               Copyright (C) 2000-2002 by the OpenSG Forum                 *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

/*****************************************************************************\
 *****************************************************************************
 **                                                                         **
 **                  This file is automatically generated.                  **
 **                                                                         **
 **          Any changes made to this file WILL be lost when it is          **
 **           regenerated, which can become necessary at any time.          **
 **                                                                         **
 *****************************************************************************
\*****************************************************************************/


#ifndef _OSGCARBONWINDOWFIELDS_H_
#define _OSGCARBONWINDOWFIELDS_H_
#ifdef __sgi
#pragma once
#endif

#include <OpenSG/OSGConfig.h>

#include <OpenSG/OSGFieldContainerPtr.h>
#include <OpenSG/OSGNodeCoreFieldDataType.h>
#include <OpenSG/OSGWindowCarbonDef.h>

#include <OpenSG/OSGWindowFields.h>

OSG_BEGIN_NAMESPACE

class CarbonWindow;

#if !defined(OSG_DO_DOC)   // created as a dummy class, remove to prevent doubles
//! CarbonWindowPtr

typedef FCPtr<WindowPtr, CarbonWindow> CarbonWindowPtr;

#endif

#if !defined(OSG_DO_DOC) || (OSG_DOC_LEVEL >= 3)
/*! \ingroup GrpWindowCarbonFieldTraits
 */
#if !defined(OSG_DOC_DEV_TRAITS)
/*! \hideinhierarchy */
#endif

template <>
struct FieldDataTraits<CarbonWindowPtr> : 
    public FieldTraitsRecurseMapper<CarbonWindowPtr, true>
{
    static DataType             _type;

    enum                        { StringConvertable = 0x00 };
    enum                        { bHasParent        = 0x01 };

    static DataType   &getType (void) { return _type;        }

    static const char *getSName(void) { return "SFCarbonWindowPtr"; }
    static const char *getMName(void) { return "MFCarbonWindowPtr"; }
};

#if !defined(OSG_DOC_DEV_TRAITS)
/*! \class  FieldTraitsRecurseMapper<CarbonWindowPtr, true>
    \hideinhierarchy
 */
#endif

#endif // !defined(OSG_DO_DOC) || (OSG_DOC_LEVEL >= 3)


#if !defined(OSG_DO_DOC) || defined(OSG_DOC_FIELD_TYPEDEFS)
/*! \ingroup GrpWindowCarbonFieldSingle */

typedef SField<CarbonWindowPtr> SFCarbonWindowPtr;
#endif

#ifndef OSG_COMPILECARBONWINDOWINST
OSG_DLLEXPORT_DECL1(SField, CarbonWindowPtr, OSG_WINDOWCARBONLIB_DLLTMPLMAPPING)
#endif

#if !defined(OSG_DO_DOC) || defined(OSG_DOC_FIELD_TYPEDEFS)
/*! \ingroup GrpWindowCarbonFieldMulti */

typedef MField<CarbonWindowPtr> MFCarbonWindowPtr;
#endif

#ifndef OSG_COMPILECARBONWINDOWINST
OSG_DLLEXPORT_DECL1(MField, CarbonWindowPtr, OSG_WINDOWCARBONLIB_DLLTMPLMAPPING)
#endif

OSG_END_NAMESPACE

#define OSGCARBONWINDOWFIELDS_HEADER_CVSID "@(#)$Id: OSGCarbonWindowFields.h,v 1.1 2006/08/04 09:18:19 pdaehne Exp $"

#endif /* _OSGCARBONWINDOWFIELDS_H_ */
