/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *               Copyright (C) 2000-2002 by the OpenSG Forum                 *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

/*****************************************************************************\
 *****************************************************************************
 **                                                                         **
 **                  This file is automatically generated.                  **
 **                                                                         **
 **          Any changes made to this file WILL be lost when it is          **
 **           regenerated, which can become necessary at any time.          **
 **                                                                         **
 *****************************************************************************
\*****************************************************************************/


#ifndef _OSGCOCOAWINDOWFIELDS_H_
#define _OSGCOCOAWINDOWFIELDS_H_
#ifdef __sgi
#pragma once
#endif

#include <OpenSG/OSGConfig.h>

#include <OpenSG/OSGFieldContainerPtr.h>
#include <OpenSG/OSGNodeCoreFieldDataType.h>
#include <OpenSG/OSGWindowCocoaDef.h>

#include <OpenSG/OSGWindowFields.h>

OSG_BEGIN_NAMESPACE

class CocoaWindow;

#if !defined(OSG_DO_DOC)   // created as a dummy class, remove to prevent doubles
//! CocoaWindowPtr

typedef FCPtr<WindowPtr, CocoaWindow> CocoaWindowPtr;

#endif

#if !defined(OSG_DO_DOC) || (OSG_DOC_LEVEL >= 3)
/*! \ingroup GrpWindowCocoaFieldTraits
 */
#if !defined(OSG_DOC_DEV_TRAITS)
/*! \hideinhierarchy */
#endif

template <>
struct FieldDataTraits<CocoaWindowPtr> : 
    public FieldTraitsRecurseMapper<CocoaWindowPtr, true>
{
    static DataType             _type;                       

    enum                        { StringConvertable = 0x00 };
    enum                        { bHasParent        = 0x01 };

    static DataType   &getType (void) { return _type;        }

    static const char *getSName(void) { return "SFCocoaWindowPtr"; }
    static const char *getMName(void) { return "MFCocoaWindowPtr"; }
};

#if !defined(OSG_DOC_DEV_TRAITS)
/*! \class  FieldTraitsRecurseMapper<CocoaWindowPtr, true>
    \hideinhierarchy
 */
#endif

#endif // !defined(OSG_DO_DOC) || (OSG_DOC_LEVEL >= 3)


#if !defined(OSG_DO_DOC) || defined(OSG_DOC_FIELD_TYPEDEFS)
/*! \ingroup GrpWindowCocoaFieldSingle */

typedef SField<CocoaWindowPtr> SFCocoaWindowPtr;
#endif

#ifndef OSG_COMPILECOCOAWINDOWINST
OSG_DLLEXPORT_DECL1(SField, CocoaWindowPtr, OSG_WINDOWCOCOALIB_DLLTMPLMAPPING)
#endif

#if !defined(OSG_DO_DOC) || defined(OSG_DOC_FIELD_TYPEDEFS)
/*! \ingroup GrpWindowCocoaFieldMulti */

typedef MField<CocoaWindowPtr> MFCocoaWindowPtr;
#endif

#ifndef OSG_COMPILECOCOAWINDOWINST
OSG_DLLEXPORT_DECL1(MField, CocoaWindowPtr, OSG_WINDOWCOCOALIB_DLLTMPLMAPPING)
#endif

OSG_END_NAMESPACE

#define OSGCOCOAWINDOWFIELDS_HEADER_CVSID "@(#)$Id: OSGCocoaWindowFields.h,v 1.1 2006/10/16 17:24:24 pdaehne Exp $"

#endif /* _OSGCOCOAWINDOWFIELDS_H_ */
