/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *               Copyright (C) 2000-2002 by the OpenSG Forum                 *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

/*****************************************************************************\
 *****************************************************************************
 **                                                                         **
 **                  This file is automatically generated.                  **
 **                                                                         **
 **          Any changes made to this file WILL be lost when it is          **
 **           regenerated, which can become necessary at any time.          **
 **                                                                         **
 *****************************************************************************
\*****************************************************************************/


#ifndef _OSGFOXWINDOWFIELDS_H_
#define _OSGFOXWINDOWFIELDS_H_
#ifdef __sgi
#pragma once
#endif

#include <OpenSG/OSGConfig.h>

#include <OpenSG/OSGFieldContainerPtr.h>
#include <OpenSG/OSGNodeCoreFieldDataType.h>
#include <OpenSG/OSGWindowFOXDef.h>

#ifdef WIN32
# include <OpenSG/OSGWIN32WindowFields.h>
#else
# include <OpenSG/OSGXWindowFields.h>
#endif

OSG_BEGIN_NAMESPACE

class FOXWindow;

#ifdef WIN32
typedef FCPtr<WIN32WindowPtr, FOXWindow> FOXWindowPtr;
#else
typedef FCPtr<XWindowPtr,     FOXWindow> FOXWindowPtr;
#endif

#if !defined(OSG_DO_DOC) || (OSG_DOC_LEVEL >= 3)
/*! \ingroup GrpWindowFOXFieldTraits
 */
#if !defined(OSG_DOC_DEV_TRAITS)
/*! \hideinhierarchy */
#endif

template <>
struct FieldDataTraits<FOXWindowPtr> : 
    public FieldTraitsRecurseMapper<FOXWindowPtr, true>
{
    static DataType             _type;                       

    enum                        { StringConvertable = 0x00 };
    enum                        { bHasParent        = 0x01 };

    static DataType &getType (void) { return _type;        }

    static char     *getSName(void) { return "SFFOXWindowPtr"; }
    static char     *getMName(void) { return "MFFOXWindowPtr"; }
};

#if !defined(OSG_DOC_DEV_TRAITS)
/*! \class  FieldTraitsRecurseMapper<FOXWindowPtr, true>
    \hideinhierarchy
 */
#endif

#endif // !defined(OSG_DO_DOC) || (OSG_DOC_LEVEL >= 3)


#if !defined(OSG_DO_DOC) || defined(OSG_DOC_FIELD_TYPEDEFS)
/*! \ingroup GrpWindowFOXFieldSingle */

typedef SField<FOXWindowPtr> SFFOXWindowPtr;
#endif

#ifndef OSG_COMPILEFOXWINDOWINST
OSG_DLLEXPORT_DECL1(SField, FOXWindowPtr, OSG_WINDOWFOXLIB_DLLTMPLMAPPING)
#endif

#if !defined(OSG_DO_DOC) || defined(OSG_DOC_FIELD_TYPEDEFS)
/*! \ingroup GrpWindowFOXFieldMulti */

typedef MField<FOXWindowPtr> MFFOXWindowPtr;
#endif

#ifndef OSG_COMPILEFOXWINDOWINST
OSG_DLLEXPORT_DECL1(MField, FOXWindowPtr, OSG_WINDOWFOXLIB_DLLTMPLMAPPING)
#endif

OSG_END_NAMESPACE

#define OSGFOXWINDOWFIELDS_HEADER_CVSID "@(#)$Id: $"

#endif /* _OSGFOXWINDOWFIELDS_H_ */
